//+------------------------------------------------------------------+
//|                                        Vertical_Coloured_RSI.mq4 |
//+------------------------------------------------------------------+
//mod2009fxtsd
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_separate_window

//#property indicator_maximum 100
//#property indicator_minimum 0

#property indicator_buffers 4

#property indicator_color1 DeepSkyBlue
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red
#property indicator_color4 Red

#property indicator_level1     70
#property indicator_level2     50
#property indicator_level3     30
#property indicator_levelcolor DarkSlateGray

//---- input parameters
extern int     RSIPeriod         =  14;
extern int     RSIPrice          =  0;
      
//---- buffers

double Higher1[];
double Higher2[];
double Lower1[];
double Lower2[];
double RSI[];

int init()
{
   IndicatorBuffers(5); 
   SetIndexBuffer(0, Higher1);
   SetIndexBuffer(1, Higher2);
   SetIndexBuffer(2, Lower1);
   SetIndexBuffer(3, Lower2);
   SetIndexBuffer(4, RSI);
   SetIndexLabel(0, "RSI");
   SetIndexLabel(1, "RSI");
   SetIndexLabel(2, "RSI");
   SetIndexLabel(3, "RSI");
   
   SetIndexDrawBegin(0, RSIPeriod + 1);
   SetIndexDrawBegin(1, RSIPeriod + 1);
   SetIndexDrawBegin(2, RSIPeriod + 1);   
   SetIndexDrawBegin(3, RSIPeriod + 1);
   
   IndicatorShortName("Coloured RSI "+RSIPeriod);
   
   IndicatorDigits(2);

   return(0);
}

int start()
{
   int ToCount = Bars - IndicatorCounted();
int cnt;


   for ( cnt = ToCount - 1; cnt >= 0; cnt--)
      {

      RSI[cnt] = iRSI(NULL, 0, RSIPeriod, RSIPrice, cnt);


      if (RSI[cnt] > RSI[cnt + 1])
            {
               Higher1[cnt] = RSI[cnt];
               Lower1[cnt] =  EMPTY_VALUE;
            }
       else
            {
               Higher1[cnt] = EMPTY_VALUE;
               Lower1[cnt] =  RSI[cnt];
            }
      }




   for ( cnt = ToCount - 1; cnt >= 0; cnt--)
   {

      Higher1[cnt] = EMPTY_VALUE;
      Higher2[cnt] = EMPTY_VALUE;
      Lower1[cnt]  = EMPTY_VALUE;
      Lower2[cnt]  = EMPTY_VALUE;
      
//      if (cnt == 0) break;
      
      if (RSI[cnt] > RSI[cnt + 1])
      {
         //   
         if (RSI[cnt + 1] > RSI[cnt + 2])
         {
            if (Higher1[cnt + 1] != EMPTY_VALUE)   Higher1[cnt] = RSI[cnt];
            else                                   Higher2[cnt] = RSI[cnt];
         }
         else
         {
            if (Higher1[cnt + 2] == EMPTY_VALUE)   
            {
               Higher1[cnt] = RSI[cnt];
               Higher1[cnt + 1] = RSI[cnt + 1];
            }
            else
            {
               Higher2[cnt] = RSI[cnt];
               Higher2[cnt + 1] = RSI[cnt + 1];
            }
         }
      }
      else
      {
         //   
         if (RSI[cnt + 1] < RSI[cnt + 2])
         {
            if (Lower1[cnt + 1] != EMPTY_VALUE)    Lower1[cnt] = RSI[cnt];
            else                                   Lower2[cnt] = RSI[cnt];
         }
         else
         {
            if (Lower1[cnt + 2] == EMPTY_VALUE)   
            {
               Lower1[cnt] = RSI[cnt];
               Lower1[cnt + 1] = RSI[cnt + 1];
            }
            else
            {
               Lower2[cnt] = RSI[cnt];
               Lower2[cnt + 1] = RSI[cnt + 1];
            }
         }
      }





   }




   
   return(0);
}